
#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File

#pragma CODE_SECTION(InitFlash, "ramfuncs");

#define CPU_FREQ 	 150E6
#define LSPCLK_FREQ  CPU_FREQ/4
#define SCI_FREQ 	 100E3
#define SCI_PRD 	 (LSPCLK_FREQ/(SCI_FREQ*8))-1

// Prototype statements for functions found within this file.
__interrupt void scibTxFifoIsr(void);
__interrupt void scibRxFifoIsr(void);
void scib_fifo_init(void);

Uint16 rdataB[8];    // Received data for SCI-A

extern Uint16 RamfuncsLoadStart;
extern Uint16 RamfuncsLoadEnd;
extern Uint16 RamfuncsRunStart;
extern Uint16 RamfuncsLoadSize;

void Delay()
{
	unsigned int i,j;
	for(i = 0;i < 500;i++)
		for(j = 0;j < 500;j++);
}

unsigned char Recv_dat = 0x00;
void main(void)
{
   Uint16 i;
   unsigned char SendChar = 0x00;

   InitSysCtrl();
   InitSciGpio();
   DINT;

   InitPieCtrl();
   IER = 0x0000;
   IFR = 0x0000;
   InitPieVectTable();

   MemCopy(&RamfuncsLoadStart, &RamfuncsLoadEnd, &RamfuncsRunStart);
   InitFlash();

   EALLOW;
   PieVectTable.SCIRXINTB = &scibRxFifoIsr;
//   PieVectTable.SCITXINTB = &scibTxFifoIsr;
   EDIS;

   scib_fifo_init();  // Init SCI-B

   PieCtrlRegs.PIECTRL.bit.ENPIE = 1;   // Enable the PIE block
   PieCtrlRegs.PIEIER9.bit.INTx3=1;     // PIE Group 9, INT3
//   PieCtrlRegs.PIEIER9.bit.INTx4=1;     // PIE Group 9, INT4
   IER = 0x100;
   EINT;

   while(1)
   {
	   ScibRegs.SCITXBUF=0xAA;

	   Delay();Delay();Delay();Delay();
	   Delay();Delay();Delay();Delay();
	   Delay();Delay();Delay();Delay();
	   SendChar++;
	   SendChar &= 0xFF;

   }
}
/*
__interrupt void scibTxFifoIsr(void)
{
    Uint16 i;
    for(i=0; i< 8; i++)
    {
 	   ScibRegs.SCITXBUF=sdataB[i];     // Send data
	}

    for(i=0; i< 8; i++)                 //Increment send data for next cycle
    {
 	   sdataB[i] = (sdataB[i]-1) & 0x00FF;
	}

	ScibRegs.SCIFFTX.bit.TXFFINTCLR=1;  // Clear Interrupt flag
	PieCtrlRegs.PIEACK.all|=0x100;      // Issue PIE ACK
}
*/
__interrupt void scibRxFifoIsr(void)
{
    Uint16 i;
	unsigned char Recev_dat = 0x00;//Tried also for unsigned int

	   Recev_dat=ScibRegs.SCIRXBUF.all;	 // Read data

//	ScibRegs.SCIFFRX.bit.RXFIFORESET = 1;
	ScibRegs.SCIFFRX.bit.RXFFOVRCLR=1;  // Clear Overflow flag
	ScibRegs.SCIFFRX.bit.RXFFINTCLR=1; 	// Clear Interrupt flag
	PieCtrlRegs.PIEACK.all|=0x100;  	// Issue PIE ack
}

void scib_fifo_init()
{
   ScibRegs.SCICCR.all =0x0007;    // 1 stop bit,  No loopback
                                   // No parity,8 char bits,
                                   // async mode, idle-line protocol
   ScibRegs.SCICTL1.all =0x0003;   // enable TX, RX, internal SCICLK,
                                   // Disable RX ERR, SLEEP, TXWAKE
//   ScibRegs.SCICTL2.bit.TXINTENA =1;
   ScibRegs.SCICTL2.bit.RXBKINTENA =1;
   ScibRegs.SCIHBAUD    = 0x01;
   ScibRegs.SCILBAUD    = 0xE7;//SCI_PRD;1e7
   ScibRegs.SCICCR.bit.LOOPBKENA =0; // Enable loop back
   ScibRegs.SCIFFTX.all=0xC021;
   ScibRegs.SCIFFRX.all=0x0021;
   ScibRegs.SCIFFCT.all=0x00;

   ScibRegs.SCICTL1.all =0x0023;     // Relinquish SCI from Reset
   ScibRegs.SCIFFTX.bit.TXFIFOXRESET=1;
   ScibRegs.SCIFFRX.bit.RXFIFORESET=1;
}
